<template lang="pug">
  div.discord.container
    el-row(justify="center" align="middle" type="flex")
      h1 #[span.highlight Coco]: The Auto-Gallery
    el-row( justify="center" align="middle" type="flex")
      el-row.login.card(justify="center" type="flex")
        el-card
          el-row(justify="center" align="middle" type="flex")
            h2 #[i.bx.bx-link] Pair
          //- OK
          div(v-if="pair && !loading")
            el-row(justify="center" align="middle" type="flex")
              h3 Editing Channel Pair \#{{pair.id}}
            el-row(justify="center" align="middle" type="flex")
              span Need #[NuxtLink(to="/help") #[el-tag help]]?
            el-form(ref="pair" :model="pair" label-width="3rem")
              el-divider Basic
              el-form-item(label="Active")
                el-switch(v-model="pair.settings.active" active-color="#67C23A" inactive-color="#F56C6C")
              el-form-item(label="Name")
                el-input(v-model="pair.name")
            el-divider Channels
            el-form(ref="channels" :model="pair" label-width="3rem")
              el-form-item(label="Safe")
                el-row(justify="left" type="flex")
                  el-input(v-model="pair.sfw.full")
                  el-divider(direction="vertical")
                  el-button(:disabled="testing" @click="runTest(pair.sfw.full)") Test
              el-form-item(label="NSFW")
                el-row(justify="left" type="flex")
                  el-input(v-model="pair.nsfw.full")
                  el-divider(direction="vertical")
                  el-button(:disabled="testing" @click="runTest(pair.nsfw.full)") Test
              el-row(justify="center" type="flex")
                p Please test the channels before saving to make sure they work as intended.
            el-divider Tags
            el-form(ref="tags" :model="pair.settings.tags" label-width="4rem")
              el-form-item(label="NSFW")
                el-select(v-model="pair.settings.tags.nsfw" multiple allow-create filterable default-first-option clearable :disabled="!pair.settings.tags.ratings.questionable")
              el-form-item(label="Excluded")
                el-select(v-model="pair.settings.tags.exclude" multiple allow-create filterable default-first-option clearable)
              el-form-item(label="Required")
                el-select(v-model="pair.settings.tags.require" multiple allow-create filterable default-first-option clearable)
              el-form-item(label="Ratings")
                el-checkbox(v-model="pair.settings.tags.ratings.safe") Safe
                el-checkbox(v-model="pair.settings.tags.ratings.questionable") Questionable
                el-checkbox(v-model="pair.settings.tags.ratings.explicit") Explicit
            el-divider Sources
            el-form(ref="sources" :model="pair.settings.sources" label-width="5rem")
              el-form-item(label="Sites")
                el-checkbox(v-model="pair.settings.sources.sites.yandere") Yande.re
                el-checkbox(v-model="pair.settings.sources.sites.konachan") Konachan
                el-checkbox(v-model="pair.settings.sources.sites.safebooru") Safebooru
                el-checkbox(v-model="pair.settings.sources.sites.reddit") Reddit
              el-form-item(label="Subreddits")
                el-select(v-model="pair.settings.sources.subs" multiple allow-create filterable default-first-option clearable :disabled="!pair.settings.sources.sites.reddit")
            el-divider Margins
            el-form(ref="margins" :model="pair.settings.margins" label-width="6rem")
              el-form-item(label="Active Only")
                el-switch(v-model="pair.settings.margins.active" active-color="#67C23A" inactive-color="#F56C6C")
              el-form-item(label="Min. Age")
                el-input-number(v-model="pair.settings.margins.age")
              el-form-item(label="Min. Score")
                el-input-number(v-model="pair.settings.margins.score")
          //- LOADING
          div(v-else-if="loading")
            el-row(justify="center" align="middle" type="flex")
              p #[i.bx.bx-spa] Loading...
            el-row(justify="center" type="flex")
              p(v-loading="loading" element-loading-background="rgba(255, 255, 255, 0.75)") {{quote}}
            el-row(justify="center" type="flex")
              p Please wait while we fetch the settings for this pair...
          //- ERROR
          div(v-else)
            el-row(justify="center" align="middle" type="flex")
              p #[i.bx.bx-ghost] You aren't supposed to be here, it seems.
            el-divider Please...
            el-row(justify="center" type="flex")
              NuxtLink(to="/") #[el-button(type="primary") #[i.bx.bx-home] Go Home]
          el-divider(v-if="pair && !loading")
          el-row(v-if="pair && !loading" justify="center" type="flex")
            el-button(type="success" @click="save()" :disabled="saving") #[i.bx.bx-save] Save
            el-divider(direction="vertical")
            NuxtLink(to="/dashboard") #[el-button(type="danger" plain) #[i.bx.bx-x] Cancel]
</template>

<script lang="ts">
import Vue from 'vue'

import Easter from '@/middleware/easter'

const easter = new Easter()

function getQuote () {
  const quoter = easter.pick()
  let text = quoter.quotes[Math.floor(Math.random() * quoter.quotes.length)]
  text = `${quoter.icon} ${text}`
  return text
}

async function getPair (token: string, id: string) {
  const api = `/api/v1/pair/${id}`
  const resp = await fetch(api, {
    method: 'GET',
    headers: {
      Authorization: token
    }
  })
  return resp
}

// async function getTags (token: string) {
//   const api = '/api/v1/tags'
//   const resp = await fetch(api, {
//     method: 'GET',
//     headers: {
//       Authorization: token
//     }
//   })
//   return resp
// }

async function testChannel (token: string, uri: string) {
  const api = '/api/v1/test'
  return await fetch(api, {
    method: 'POST',
    headers: {
      Authorization: token,
      'Content-Type': 'application/x-www-form-urlencoded'
    },
    body: `uri=${uri}`
  })
}

async function putPair (token: string, data: any) {
  const api = `/api/v1/pair/${data.id}`
  return await fetch(api, {
    method: 'PUT',
    headers: {
      Authorization: token,
      'Content-Type': 'application/json'
    },
    body: JSON.stringify(data)
  })
}

function frontToBackPair (original: any) {
  const pair = JSON.parse(JSON.stringify(original))
  const sfwPieces = pair.sfw.full.split('/')
  const sfwToken = sfwPieces[sfwPieces.length - 1]
  const sfwId = sfwPieces[sfwPieces.length - 2]
  pair.sfw.id = sfwId
  pair.sfw.token = sfwToken
  const nsfwPieces = pair.nsfw.full.split('/')
  const nsfwToken = nsfwPieces[nsfwPieces.length - 1]
  const nsfwId = nsfwPieces[nsfwPieces.length - 2]
  pair.nsfw.id = nsfwId
  pair.nsfw.token = nsfwToken
  if (!pair.sfw.full) {
    pair.sfw = null
  }
  if (!pair.nsfw.full) {
    pair.nsfw = null
  }
  return pair
}

function backToFrontPair (pair: any) {
  return {
    id: pair.id,
    sfw: pair.sfw ? pair.sfw : { id: 0, token: '', full: '' },
    nsfw: pair.nsfw ? pair.nsfw : { id: 0, token: '', full: '' },
    name: pair.name,
    settings: pair.settings
      ? pair.settings
      : {
          tags: {
            nsfw: [],
            exclude: [],
            require: [],
            ratings: {
              safe: false,
              questionable: false,
              explicit: false
            }
          },
          sources: {
            sites: {
              yandere: false,
              konachan: false,
              safebooru: false,
              reddit: false
            },
            subs: []
          },
          margins: {
            age: 0,
            score: 0,
            active: false
          },
          active: false
        }
  }
}

function sortTags (tags: any): any {
  const keys = ['exclude', 'nsfw', 'require']
  keys.forEach((key: string) => {
    tags[key].sort()
  })
}

export default Vue.extend({
  data () {
    return {
      loading: false,
      testing: false,
      saving: false,
      pairId: this.$route.query.id as string,
      pair: null as any,
      token: window.localStorage.getItem('coco_token') as string,
      quote: getQuote()
    }
  },
  async mounted () {
    const pairResp = await getPair(this.token, this.pairId)
    if (pairResp.status === 200) {
      const pair = await pairResp.json()
      sortTags(pair.settings.tags)
      pair.settings.sources.subs.sort()
      this.pair = backToFrontPair(pair)
    }
    this.loading = false
  },
  methods: {
    runTest (uri: string) {
      const ctx = this
      ctx.testing = true
      testChannel(ctx.token, uri).then((resp) => {
        if (resp.status === 201) {
          ctx.$notify({ title: 'Ok', message: 'Testing the channel succeeded.', type: 'success' })
        } else {
          ctx.$notify({ title: 'Error', message: 'Testing the channel failed.', type: 'error' })
        }
      }).catch((err) => {
        ctx.$notify({ title: 'Error', message: `Testing the channel failed: ${err}.`, type: 'error' })
      }).finally(() => {
        ctx.testing = false
      })
    },
    save () {
      const ctx = this
      ctx.saving = true
      const pair = frontToBackPair(ctx.pair)
      putPair(ctx.token, pair).then((resp) => {
        resp.text().then((body) => {
          if (resp.status === 200) {
            ctx.$notify({ title: 'Ok', message: 'Saving the channel succeeded.', type: 'success' })
          } else {
            ctx.$notify({ title: 'Error', message: `Saving the pair failed. ${body}`, type: 'error' })
          }
        })
      }).catch((err) => {
        ctx.$notify({ title: 'Error', message: `Saving the channel failed: ${err}.`, type: 'error' })
      }).finally(() => {
        ctx.saving = false
      })
    }
  }
})
</script>

<style lang="scss" scoped>
.float.right {
  float: right;
}
.el-select {
  display: flex;
}
</style>
